package cn.iocoder.yudao.module.delivery.listener;

import cn.iocoder.yudao.framework.apollo.core.event.Customer.ReceiveCustomerCalTypeEvent;
import cn.iocoder.yudao.module.customer.service.customer.CustomerService;
//import cn.iocoder.yudao.module.delivery.entity.deptex.zTest;
import cn.iocoder.yudao.module.delivery.service.Impl.OrderServiceExtImpl;
import cn.iocoder.yudao.module.delivery.service.OrderServiceExt;
//import cn.iocoder.yudao.module.delivery.service.ZTestService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;

/*
 移交，接收客户是计算客户业绩类型
 */
@Component("ReceiveCustomerCalTypeListener")
@AllArgsConstructor
@Slf4j
public class ReceiveCustomerCalTypeListener {

    @Resource
    private CustomerService customerService;

    @Resource
    private OrderServiceExt orderServiceExt;

//    @Resource
//    private ZTestService zTestService;

    @EventListener(ReceiveCustomerCalTypeEvent.class)
    public void CalculateCustomerTypePushEvent(
            ReceiveCustomerCalTypeEvent event) {
        //CustomerServiceImpl confirmCustomer 函数中触发事件 客户经理直接确认接收
        //CustomerServiceImpl receiveCustomer 函数中触发，移交，系统分配，接收时判断
        //CustomerServiceImpl updateCustomer  函数中触发，完善客户信息
//        zTest m=new zTest();
        String sMsg="接收客户"+event.getCustomerId();
        if (event.getIsNew() == true) {
            //移交接收前是新客户
            sMsg+=",新客户";
            boolean bR = IsHavingRuCanOrder(event);
            if (bR == true) {
                sMsg+=",有业绩";
                //客户有订单已入仓且业绩归属客户方，接收后客户业绩类型，变更为老客户
                customerService.updateCustomerNewOrOld(event.getCustomerId(),
                        false);
            } else {
                sMsg+=",无业绩";
                //客户没有订单已入仓,变更为新客户
                //维持老客户不变，可不做任何逻辑操作
            }
        } else {
            //移交接收前是老客户
            //维持老客户不变，可不做任何逻辑操作
            sMsg+=",老客户";
        }
//        m.setTestname(sMsg);
//        m.setCreatedate(new Date());
//        zTestService.save(m);
    }

    /*
     判断客户是否有已入参订单
     select COUNT(id) from ecw_target_log where deleted = 0 and customer_id = 17442
     需要在2个表中查询数据
     */
    private boolean IsHavingRuCanOrder(ReceiveCustomerCalTypeEvent event) {
        //判断客户是否有已入参订单
       int c=orderServiceExt.IsHavingOrder(event);
        if (c==0)
            return false;
        else
            return true;
    }
}
