package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.module.delivery.entity.CustomerAnalysisResp;
import cn.iocoder.yudao.module.delivery.entity.CustomerReportReq;
import cn.iocoder.yudao.module.delivery.entity.CustomerReportResp;
import cn.iocoder.yudao.module.delivery.mapper.CustomerAnalysisMapper;
import cn.iocoder.yudao.module.delivery.mapper.CustomerReportMapper;
import cn.iocoder.yudao.module.delivery.service.CustomerReportService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("CustomerReportService")
public class CustomerReportImpl implements CustomerReportService {

    @Autowired
    private CustomerReportMapper customerReportMapper;


    public PageResult<CustomerReportResp> getListPage(CustomerReportReq req) {

        IPage<CustomerReportResp> mpPage = MyBatisUtils.buildPage(req);
        long total = customerReportMapper.GetCount(req);
        System.out.println("符合条件的客户总数："+String.valueOf(total));
        int start = (req.getPageNo() - 1) * req.getPageSize();
        int size = req.getPageSize();

        req.setSize(size);
        req.setStart(start);

        List<CustomerReportResp> list = customerReportMapper.getListPage(req);

        return new PageResult<>(list, total, mpPage.getSize(),
                req.getPageNo(), (total + mpPage.getSize() - 1) / mpPage.getSize());

    }
}
