package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.module.delivery.entity.EcwReportPermissionResp;
import com.baomidou.mybatisplus.core.metadata.IPage;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.delivery.entity.EcwReportPermission;
import cn.iocoder.yudao.module.delivery.entity.EcwReportPermissionPageReq;
import cn.iocoder.yudao.module.delivery.mapper.EcwReportPermissionMapper;
import cn.iocoder.yudao.module.delivery.service.EcwReportPermissionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import javax.validation.Valid;

/**
 * 报表权限(EcwReportPermission)表服务实现类
 *
 * @author
 * @since 2024-04-09 23:10:41
 */
@Service("ecwReportPermissionService")
public class EcwReportPermissionServiceImpl extends ServiceImpl<EcwReportPermissionMapper, EcwReportPermission> implements EcwReportPermissionService {

    @Autowired
    private EcwReportPermissionMapper ecwReportPermissionMapper;

    /**
     * 创建测试
     *
     * @param createReq 创建信息
     * @return 编号
     */
    public Long create(@Valid EcwReportPermission createReq) {
        ecwReportPermissionMapper.insert(createReq);
        return createReq.getId();
    }

    /**
     * 更新测试
     *
     * @param updateReq 更新信息
     */
    public void update(@Valid EcwReportPermission updateReq) {
        ecwReportPermissionMapper.updateById(updateReq);
    }

    /**
     * 物理删除记录，避免表存在无用的记录，影响查询效率
     *
     * @param id 编号
     */
    public void delete(Long id) {
        ecwReportPermissionMapper.deleteById2(id);
    }

    /**
     * 获得测试
     *
     * @param id 编号
     * @return 测试
     */
    public EcwReportPermission getModel(Long id) {
        return ecwReportPermissionMapper.selectById(id);
    }

    /**
     * 获得测试列表
     *
     * @param ids 编号
     * @return 测试列表
     */
    public List<EcwReportPermission> getQueryList(Collection<Long> ids) {
        return ecwReportPermissionMapper.selectBatchIds(ids);
    }

    /**
     * 获得测试列表, 用于 Excel 导出
     *
     * @param query 查询
     * @return 列表
     */
    public List<EcwReportPermission> selectList(EcwReportPermission query) {
        return ecwReportPermissionMapper.selectList(query);
    }

    /**
     * 获得测试分页
     *
     * @param page 分页查询
     * @param page 查询
     * @return 分页列表
     */
    public PageResult<EcwReportPermission> getListPage(EcwReportPermissionPageReq page) {
        return ecwReportPermissionMapper.selectPage(page);
    }

    /*
      自定义的分页函数
     */
    public PageResult<EcwReportPermissionResp> getListPageCustom(EcwReportPermissionPageReq page) {

        IPage<EcwReportPermission> mpPage = MyBatisUtils.buildPage(page);
        long total = ecwReportPermissionMapper.GetCount(page);
        int start = (page.getPageNo() - 1) * page.getPageSize();
        int size = page.getPageSize();

        page.setSize(size);
        page.setStart(start);

        List<EcwReportPermissionResp> list =
                ecwReportPermissionMapper.getListPageCustom(page);

        return new PageResult<>(list, total, mpPage.getSize(),
                page.getPageNo(), (total + mpPage.getSize() - 1) / mpPage.getSize());

    }


}

