package cn.iocoder.yudao.module.delivery.service.Impl;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.delivery.entity.Employee;
import cn.iocoder.yudao.module.delivery.entity.EmployeePageReq;
import cn.iocoder.yudao.module.delivery.mapper.EmployeeMapper;
import cn.iocoder.yudao.module.delivery.service.EmployeeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import javax.validation.Valid;

/**
 * (Employee)表服务实现类
 *
 * @author
 * @since 2024-03-27 21:25:56
 */
@Service("employeeService")
public class EmployeeServiceImpl extends ServiceImpl<EmployeeMapper, Employee> implements EmployeeService {

    @Autowired
    private EmployeeMapper employeeMapper;

    /**
     * 创建测试
     *
     * @param createReq 创建信息
     * @return 编号
     */
    public Long create(@Valid Employee createReq) {
        employeeMapper.insert(createReq);
        return createReq.getId();
    }

    /**
     * 更新测试
     *
     * @param updateReq 更新信息
     */
    public void update(@Valid Employee updateReq) {
        employeeMapper.updateById(updateReq);
    }

    /**
     * 删除测试
     *
     * @param id 编号
     */
    public void delete(Long id) {
        employeeMapper.deleteById(id);
    }

    /**
     * 获得测试
     *
     * @param id 编号
     * @return 测试
     */
    public Employee getModel(Long id) {
        return employeeMapper.selectById(id);
    }

    /**
     * 获得测试列表
     *
     * @param ids 编号
     * @return 测试列表
     */
    public List<Employee> getQueryList(Collection<Long> ids) {
        return employeeMapper.selectBatchIds(ids);
    }

    /**
     * 获得测试列表, 用于 Excel 导出
     *
     * @param query 查询
     * @return 列表
     */
    public List<Employee> getQueryList(Employee query) {
        return employeeMapper.selectList(query);
    }

    /**
     * 获得测试分页
     *
     * @param page 分页查询
     * @param page 查询
     * @return 分页列表
     */
    public PageResult<Employee> getListPage(EmployeePageReq page) {
        return employeeMapper.selectPage(page);
    }


}

