package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.dict.core.dto.DictDataRespDTO;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.module.delivery.entity.*;
import cn.iocoder.yudao.module.delivery.mapper.SalesAnalysisMapper;
import cn.iocoder.yudao.module.delivery.service.SalesAnalysisService;
import cn.iocoder.yudao.module.system.api.dict.DictDataApi;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/*
 */
@Service("SalesAnalysisService")
public class SalesAnalysisImpl implements SalesAnalysisService {

    @Autowired
    private SalesAnalysisMapper salesAnalysisMapper;

    @Autowired
    private DictDataApi dictDataApi;

    public List<SalesAnalysisExcelResp> getList(SalesAnalysisReq req) {
        return salesAnalysisMapper.getList(req);
    }

    /*
 根据原始信息计算逻辑展示信息
 */
    private SalesAnalysisResp calBis(SalesAnalysisResp r) {
        String sTemp = "";
        //付款方
        if (r.getDrawee().equals("1")) {
            if (r.getCfResourceType().equals("1")) {
                r.setShowResourceType("开发客户");
            } else if (r.getCfResourceType().equals("2")) {
                r.setShowResourceType("公司客户");
            }

            if (r.getCfYeJiType().equals("0")) {
                r.setShowYeJiType("老客户");

            } else if (r.getCfYeJiType().equals("1")) {
                r.setShowYeJiType("新客户");
            }
            sTemp = "发货方";
        } else if (r.getDrawee().equals("2")) {
            if (r.getShResourceType().equals("1")) {
                r.setShowResourceType("开发客户");
            } else if (r.getShResourceType().equals("2")) {
                r.setShowResourceType("公司客户");
            }

            if (r.getShYeJitype().equals("0")) {
                r.setShowYeJiType("老客户");

            } else if (r.getShYeJitype().equals("1")) {
                r.setShowYeJiType("新客户");
            }
            sTemp = "收货方";
        } else if (r.getDrawee().equals("3")) {
            if (r.getCfResourceType().equals("1")) {
                r.setShowResourceType("开发客户");
            } else if (r.getCfResourceType().equals("2")) {
                r.setShowResourceType("公司客户");
            }

            if (r.getCfYeJiType().equals("0")) {
                r.setShowYeJiType("老客户");

            } else if (r.getCfYeJiType().equals("1")) {
                r.setShowYeJiType("新客户");
            }
            sTemp = "自定义";
        }
        r.setDraweeName(sTemp);


        //计算提货率
        if (r.getSumquantity() == 0) {
            r.setShowThl("总数为0");
        } else {
            double percentage =(double)r.getPicknum()/r.getSumquantity();
            String result = String.format("%.2f", percentage);
            r.setShowThl(result);
        }

        return r;
    }


    public PageResult<SalesAnalysisResp> getListPage(SalesAnalysisReq req) {

        IPage<SalesAnalysisResp> mpPage = MyBatisUtils.buildPage(req);
        long total = salesAnalysisMapper.GetCount(req);
        System.out.println("符合条件的客户总数：" + String.valueOf(total));
        int start = (req.getPageNo() - 1) * req.getPageSize();
        int size = req.getPageSize();

        req.setSize(size);
        req.setStart(start);

        //订单状态
        List<DictDataRespDTO> dic_order_status =
                dictDataApi.getDictDatas("order_status");
        Map<String, String> map_order_status = new HashMap<>();
        for (DictDataRespDTO d : dic_order_status
        ) {
            map_order_status.put(d.getValue(), d.getLabel());
        }

        List<SalesAnalysisResp> list = salesAnalysisMapper.getListPage(req);

        int nPm = req.getStart() + 1;
        String sTemp = "";
        for (SalesAnalysisResp r : list) {
            r.setPx(nPm);
            nPm++;

            //订单状态
            r.setStatusName(map_order_status.get(r.getStatus()));

            String sType = "";
            if (r.getOrdertype() == 2) {
                //是重货，非泡货
                sType = "是/否";
            } else if (r.getOrdertype() == 3) {
                sType = "否/是";

            } else if (r.getOrdertype() == 1) {
                sType = "普货";
            }
            r.setOrdertypeShow(sType);

            //业务数据逻辑运算
            r = calBis(r);

            if (r.getUseweightunit() == null) r.setUseweightunit("无");
            if (r.getUsevolumeunit() == null) r.setUsevolumeunit("无");
            r.setZpUnitShow(r.getUseweightunit() + "/" + r.getUsevolumeunit());

        }

        return new PageResult<>(list, total, mpPage.getSize(),
                req.getPageNo(), (total + mpPage.getSize() - 1) / mpPage.getSize());


    }
}
