package cn.iocoder.yudao.module.delivery.utility;

import cn.iocoder.yudao.module.delivery.entity.Employee;
import org.apache.ibatis.jdbc.SQL;

import java.util.Map;

/*
 代码中的动态SQL语句
 */
public class ProductInfoDynaSqlProvider {
    // 分页动态查询
    public String selectWithParam(Map<String, Object> params) {
        String sql = new SQL() {
            {
                SELECT("*");
                FROM("product_info");
                if (params.get("productInfo") != null) {
                    Employee productInfo = (Employee) params.get("Employee");
                    if (productInfo.getName() != null && !"".equals(productInfo.getName())) {
                        WHERE(" code = #{productInfo.code} ");
                    }
                    if (productInfo.getName() != null && !productInfo.getName().equals("")) {
                        WHERE("  name LIKE CONCAT ('%',#{productInfo.name},'%') ");
                    }
                    if (productInfo.getEmail() != null && !productInfo.getEmail().equals("")) {
                        WHERE("  brand LIKE CONCAT ('%',#{productInfo.brand},'%') ");
                    }

                    if (productInfo.getAge() > 0) {
                        WHERE(" price > #{productInfo.priceFrom} ");
                    }

                }
            }
        }.toString();
        if (params.get("pager") != null) {
            sql += " limit #{pager.firstLimitParam} , #{pager.perPageRows}  ";
        }
        return sql;
    }

    //根据条件动态查询商品总记录数
    public String count(Map<String, Object> params) {
        return new SQL() {
            {
                SELECT("count(*)");
                FROM("product_info");

                if (params.get("productInfo") != null) {
                    Employee productInfo = (Employee) params.get("Employee");
                    if (productInfo.getName() != null && !"".equals(productInfo.getName())) {
                        WHERE(" code = #{productInfo.code} ");
                    }
                    if (productInfo.getName() != null && !productInfo.getName().equals("")) {
                        WHERE("  name LIKE CONCAT ('%',#{productInfo.name},'%') ");
                    }
                    if (productInfo.getEmail() != null && !productInfo.getEmail().equals("")) {
                        WHERE("  brand LIKE CONCAT ('%',#{productInfo.brand},'%') ");
                    }

                    if (productInfo.getAge() > 0) {
                        WHERE(" price > #{productInfo.priceFrom} ");
                    }

                }
            }
        }.toString();
    }


    //根据条件动态查询总记录数
    public String count2(Map<String, Object> params) {
        return new SQL() {
            {
                SELECT("count(*)");
                FROM("user_info");
                if (params.get("userInfo") != null) {
                    Employee userInfo = (Employee) params.get("userInfo");
                    if (userInfo.getName() != null && !userInfo.getName().equals("")) {
                        WHERE("  userName LIKE CONCAT ('%',#{userInfo.userName},'%') ");
                    }
                }
            }
        }.toString();
    }
}
